#!/usr/bin/perl -w

##  Copyright 2003 Rien Croonenborghs
##
##    This file is part of file2divx3pass.
##    file2divx4pass is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 2 of the License, or
##    (at your option) any later version.
##    file2divx3pass is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##    You should have received a copy of the GNU General Public License
##    along with file2divx3pass; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use Gtk;
init Gtk;

use strict;

package File2DiVX3Pass;

my $true  = 1;
my $false = 0;
my $VERSION = "1.0b8";



sub new
{
	my $class = shift;
	my $widgets;

	my @menu_items = (
		{ path        => '/_File',
     		type        => '<Branch>' },
	   		{ path        => '/File/_New project',
     			accelerator => '<control>N',
     			callback    =>  sub { MenuNew($widgets) } },
	   		{ path        => '/File/_Open project',
     			accelerator => '<control>O',
     			callback    => sub { MenuOpen($widgets) } },
	   		{ path        => '/File/_Save project',
     			accelerator => '<control>S',
     			callback    => sub { MenuSave($widgets) } },

		{ path        => '/Se_ttings',
     		type        => '<Branch>' },
	   		{ path        => '/Settings/S_ave Settings',
     			accelerator => '<control>A',
     			callback    =>  sub { MenuSaveSettings($widgets) } },
	   		{ path        => '/Settings/Loa_d Settings',
     			accelerator => '<control>D',
     			callback    => sub { MenuLoadSettings($widgets) } },

   		{ path        => '/File/sep1',
     		type        => '<Separator>' },

   		{ path        => '/File/_Batch encode',
     		accelerator => '<control>B',
     		callback    => sub{ MenuBatchEncode($widgets) } },

   		{ path        => '/File/sep2',
     		type        => '<Separator>' },

   		{ path        => '/File/Quit',
		accelerator => '<control>Q',
     		callback    => sub { Gtk->exit( 0 ); } },

		{ path        => '/_Help',
 		type        => '<LastBranch>' },

	   		{ path        => '/_Help/About',
			callback    => sub { MenuAbout( $VERSION ); } }
	);




	## main window
	##############
	$widgets->{'wdwMain'} = new Gtk::Window( "toplevel" );
	$widgets->{'wdwMain'}->set_title( "File2DiVX3Pass ".$VERSION );
	$widgets->{'wdwMain'}->set_policy( $false, $false, $true );
	$widgets->{'wdwMain'}->set_position( "center" );
	$widgets->{'wdwMain'}->border_width( 5 );

	## maintop vbox
	###############
	$widgets->{'vbMainTop'} = new Gtk::VBox( $false, 2 );
	$widgets->{'wdwMain'}->add( $widgets->{'vbMainTop'} );

	## menu
	#######
	$widgets->{'mbarMenu'} = MakeMenu( $widgets, @menu_items );
	Add2BoxStart( $widgets->{'vbMainTop'}, $widgets->{'mbarMenu'} );

	## notebook
	###########
	$widgets->{'nbMain'} = new Gtk::Notebook();
	$widgets->{'nbMain'}->set_tab_pos( "left" );
	Add2BoxStart( $widgets->{'vbMainTop'}, $widgets->{'nbMain'} );


## IO --------------------------------------------------------------------------

	## IO VBOX
	##########
	$widgets->{'vbIO'} = new Gtk::VBox( $false, 2 );
	$widgets->{'vbIO'}->border_width( 2 );
	$widgets->{'nbMain'}->append_page( $widgets->{'vbIO'}, new Gtk::Label(" Input/Output ") );

	$widgets->{'frmI'} = new Gtk::Frame( " Input " );
	$widgets->{'frmI'}->border_width( 5 );
	$widgets->{'vbI'} = new Gtk::VBox( $false, 2 );
	$widgets->{'vbI'}->border_width( 3 );
	$widgets->{'frmI'}->add( $widgets->{'vbI'} );
	Add2BoxStart( $widgets->{'vbIO'}, $widgets->{'frmI'} );

		## input file
		#############
			$widgets->{'hbInput'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbI'}, $widgets->{'hbInput'} );
			$widgets->{'lblInput'} = new Gtk::Label( "Input file " );
			$widgets->{'entryInput'} = new Gtk::Entry();
			$widgets->{'btnInput'} = new Gtk::Button( "  Select file  " );
			$widgets->{'btnInput'}->border_width( 2 );
		Add2BoxStart( $widgets->{'hbInput'}, $widgets->{'lblInput'} );
		Add2BoxFillStart( $widgets->{'hbInput'}, $widgets->{'entryInput'} );
		Add2BoxStart( $widgets->{'hbInput'}, $widgets->{'btnInput'} );

		## subtitle file
		#############
			$widgets->{'hbSubFile'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbI'}, $widgets->{'hbSubFile'} );
			$widgets->{'chkbtnSubFile'} = new Gtk::CheckButton( "Subtitle " );
			$widgets->{'entrySubFile'} = new Gtk::Entry();
			$widgets->{'entrySubFile'}->set_sensitive( $false );
			$widgets->{'btnSubFile'} = new Gtk::Button( "  Select file  " );
			$widgets->{'btnSubFile'}->border_width( 2 );
			$widgets->{'btnSubFile'}->set_sensitive( $false );
		Add2BoxStart( $widgets->{'hbSubFile'}, $widgets->{'chkbtnSubFile'} );
		Add2BoxFillStart( $widgets->{'hbSubFile'}, $widgets->{'entrySubFile'} );
		Add2BoxStart( $widgets->{'hbSubFile'}, $widgets->{'btnSubFile'} );

		## audio / subtitle ID
		######################
		$widgets->{'hbAudioSub'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbI'}, $widgets->{'hbAudioSub'} );
			$widgets->{'chkbtnAudioID'} = new Gtk::CheckButton( "Audio ID " );
			$widgets->{'entryAudioID'} = new Gtk::Entry();
			$widgets->{'entryAudioID'}->set_sensitive( $false );
			$widgets->{'entryAudioID'}->set_usize( 50, 0 );
			$widgets->{'chkbtnSubID'} = new Gtk::CheckButton( "Subtitle ID " );
			$widgets->{'entrySubID'} = new Gtk::Entry();
			$widgets->{'entrySubID'}->set_sensitive( $false );
			$widgets->{'entrySubID'}->set_usize( 50, 0 );
		Add2BoxStart( $widgets->{'hbAudioSub'}, $widgets->{'chkbtnAudioID'} );
		Add2BoxStart( $widgets->{'hbAudioSub'}, $widgets->{'entryAudioID'} );
		Add2BoxStart( $widgets->{'hbAudioSub'}, $widgets->{'chkbtnSubID'} );
		Add2BoxStart( $widgets->{'hbAudioSub'}, $widgets->{'entrySubID'} );


		## output file
		##############
	$widgets->{'frmO'} = new Gtk::Frame( " Output " );
	$widgets->{'frmO'}->border_width( 5 );
	$widgets->{'vbO'} = new Gtk::VBox( $false, 2 );
	$widgets->{'vbO'}->border_width( 3 );
	$widgets->{'frmO'}->add( $widgets->{'vbO'} );
	Add2BoxStart( $widgets->{'vbIO'}, $widgets->{'frmO'} );
		$widgets->{'hbOutput'} = new Gtk::HBox( $false, 2 );
	Add2BoxStart( $widgets->{'vbO'}, $widgets->{'hbOutput'} );
			$widgets->{'lblOutput'} = new Gtk::Label( "Output file" );
			$widgets->{'entryOutput'} = new Gtk::Entry();
			$widgets->{'entryOutput'}->set_text( "out.divx.avi" );
		Add2BoxStart( $widgets->{'hbOutput'}, $widgets->{'lblOutput'} );
		Add2BoxFillStart( $widgets->{'hbOutput'}, $widgets->{'entryOutput'} );


## AUDIO -----------------------------------------------------------------------

	## AVA VBOX
	###########
	$widgets->{'vbAVA'} = new Gtk::VBox( $false, 2 );
	$widgets->{'vbAVA'}->border_width( 2 );
	$widgets->{'nbMain'}->append_page( $widgets->{'vbAVA'}, new Gtk::Label(" Audio Settings ") );

	$widgets->{'frmA'} = new Gtk::Frame( " Audio " );
	$widgets->{'frmA'}->border_width( 5 );
	$widgets->{'vbA'} = new Gtk::VBox( $false, 2 );
	$widgets->{'vbA'}->border_width( 3 );
	$widgets->{'frmA'}->add( $widgets->{'vbA'} );
	Add2BoxStart( $widgets->{'vbAVA'}, $widgets->{'frmA'} );

		## audio codec
		##############
		$widgets->{'hbAudioCodec'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbA'}, $widgets->{'hbAudioCodec'} );
			$widgets->{'lblAudioCodec'} = new Gtk::Label( "Audio Codec" );
			$widgets->{'cmbAudioCodec'} = new Gtk::Combo();
			$widgets->{'cmbAudioCodec'}->set_popdown_strings( 'mp3', 'copy', 'pcm' );
			$widgets->{'cmbAudioCodec'}->set_usize( 75, 0);
		Add2BoxStart( $widgets->{'hbAudioCodec'}, $widgets->{'lblAudioCodec'} );
		Add2BoxStart( $widgets->{'hbAudioCodec'}, $widgets->{'cmbAudioCodec'} );

		## audio bitrate
		################
		$widgets->{'hbAudioBrate'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbA'}, $widgets->{'hbAudioBrate'} );
			$widgets->{'lblAudioBrate'} = new Gtk::Label( "Audio MP3 bitrate" );
			$widgets->{'cmbAudioBrate'} = new Gtk::Combo();
			$widgets->{'cmbAudioBrate'}->set_popdown_strings( '32', '40', '48', '56', '64', '80', '96', '112', '128', '160', '192', '224', '256', '320' );
			$widgets->{'cmbAudioBrate'}->set_usize( 50, 0);
			$widgets->{'cmbAudioBrate'}->list->select_item( 8 );
		Add2BoxStart( $widgets->{'hbAudioBrate'}, $widgets->{'lblAudioBrate'} );
		Add2BoxStart( $widgets->{'hbAudioBrate'}, $widgets->{'cmbAudioBrate'} );
			$widgets->{'lblAudioRate'} = new Gtk::Label( "Bitrate is" );
			$widgets->{'cmbAudioRate'} = new Gtk::Combo();
			$widgets->{'cmbAudioRate'}->set_popdown_strings( 'constant', 'average' );
			$widgets->{'cmbAudioRate'}->set_usize( 100, 0);
			$widgets->{'cmbAudioRate'}->list->select_item( 0 );
		Add2BoxEnd( $widgets->{'hbAudioBrate'}, $widgets->{'cmbAudioRate'} );
		Add2BoxEnd( $widgets->{'hbAudioBrate'}, $widgets->{'lblAudioRate'} );


## VIDEO -----------------------------------------------------------------------

	## AVV VBOX
	###########
	$widgets->{'vbAVV'} = new Gtk::VBox( $false, 2 );
	$widgets->{'vbAVV'}->border_width( 2 );
	$widgets->{'nbMain'}->append_page( $widgets->{'vbAVV'}, new Gtk::Label(" Video Settings ") );

	$widgets->{'frmV'} = new Gtk::Frame( " Video " );
	$widgets->{'frmV'}->border_width( 5 );
	$widgets->{'vbV'} = new Gtk::VBox( $false, 2 );
	$widgets->{'vbV'}->border_width( 3 );
	$widgets->{'frmV'}->add( $widgets->{'vbV'} );
	Add2BoxStart( $widgets->{'vbAVV'}, $widgets->{'frmV'} );

		## file length
		##############
		$widgets->{'hbLength'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbV'}, $widgets->{'hbLength'} );
			$widgets->{'lblLength'} = new Gtk::Label( "File Length" );
			$widgets->{'entryLength'} = new Gtk::Entry();
			$widgets->{'entryLength'}->set_text( StoH(0) );
			$widgets->{'entryLength'}->set_usize( 65, 0 );
		Add2BoxStart( $widgets->{'hbLength'}, $widgets->{'lblLength'} );
		Add2BoxStart( $widgets->{'hbLength'}, $widgets->{'entryLength'} );

		## cd size + output FPS
		#######################
		$widgets->{'hbSize'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbV'}, $widgets->{'hbSize'} );
			$widgets->{'lblSize'} = new Gtk::Label( "CD Size    " );
			$widgets->{'entrySize'} = new Gtk::Entry();
			$widgets->{'entrySize'}->set_text( "700" );			
			$widgets->{'entrySize'}->set_usize( 50, 0 );
			$widgets->{'lblSize2'} = new Gtk::Label( "Mb" );
		Add2BoxStart( $widgets->{'hbSize'}, $widgets->{'lblSize'} );
		Add2BoxStart( $widgets->{'hbSize'}, $widgets->{'entrySize'} );
		Add2BoxStart( $widgets->{'hbSize'}, $widgets->{'lblSize2'} );
			$widgets->{'chkbtnOutputFPS'} = new Gtk::CheckButton( "Output FPS" );
			$widgets->{'entryOutputFPS'} = new Gtk::Entry();
			$widgets->{'entryOutputFPS'}->set_text( "25" );
			$widgets->{'entryOutputFPS'}->set_sensitive( $false );
			$widgets->{'entryOutputFPS'}->set_usize( 55, 0 );
		Add2BoxEnd( $widgets->{'hbSize'}, $widgets->{'entryOutputFPS'} );
		Add2BoxEnd( $widgets->{'hbSize'}, $widgets->{'chkbtnOutputFPS'} );

		## scaling
		##########
		$widgets->{'hbScale'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbV'}, $widgets->{'hbScale'} );
			$widgets->{'lblScale'} = new Gtk::Label( "Scale to W x H" );
			$widgets->{'entryScaleWidth'} = new Gtk::Entry();
			$widgets->{'entryScaleWidth'}->set_text( "480" );
			$widgets->{'entryScaleWidth'}->set_usize( 40, 0 );
			$widgets->{'lblScalex'} = new Gtk::Label( "x" );
			$widgets->{'entryScaleHeight'} = new Gtk::Entry();
			$widgets->{'entryScaleHeight'}->set_text( "360" );
			$widgets->{'entryScaleHeight'}->set_usize( 40, 0 );
			$widgets->{'rbtnScale43'} = new Gtk::RadioButton( "4:3" );
			$widgets->{'rbtnScale169'} = new Gtk::RadioButton( "16:9", $widgets->{'rbtnScale43'} );
		Add2BoxStart( $widgets->{'hbScale'}, $widgets->{'lblScale'} );
		Add2BoxStart( $widgets->{'hbScale'}, $widgets->{'entryScaleWidth'} );
		Add2BoxStart( $widgets->{'hbScale'}, $widgets->{'lblScalex'} );
		Add2BoxStart( $widgets->{'hbScale'}, $widgets->{'entryScaleHeight'} );
		Add2BoxEnd( $widgets->{'hbScale'}, $widgets->{'rbtnScale43'} );
		Add2BoxEnd( $widgets->{'hbScale'}, $widgets->{'rbtnScale169'} );

		## video rate + bpp
		###################
		$widgets->{'hbVideoBrate'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbV'}, $widgets->{'hbVideoBrate'} );
			$widgets->{'lblVideoBrate'} = new Gtk::Label( "Video Bitrate" );
			$widgets->{'entryVideoBrate'} = new Gtk::Entry();
			$widgets->{'entryVideoBrate'}->set_usize( 55, 0 );
		Add2BoxStart( $widgets->{'hbVideoBrate'}, $widgets->{'lblVideoBrate'} );
		Add2BoxStart( $widgets->{'hbVideoBrate'}, $widgets->{'entryVideoBrate'} );
			$widgets->{'lblVideoBPP'} = new Gtk::Label( "BPP" );
			$widgets->{'entryVideoBPP'} = new Gtk::Entry();
			$widgets->{'entryVideoBPP'}->set_usize( 55, 0 );
		Add2BoxEnd( $widgets->{'hbVideoBrate'}, $widgets->{'entryVideoBPP'} );
		Add2BoxEnd( $widgets->{'hbVideoBrate'}, $widgets->{'lblVideoBPP'} );

		## lib + pass
		#############
		$widgets->{'hbCodecPass'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbV'}, $widgets->{'hbCodecPass'} );
			$widgets->{'lblCodec'} = new Gtk::Label( "Video Codec" );
			$widgets->{'cmbCodec'} = new Gtk::Combo();
			$widgets->{'cmbCodec'}->set_popdown_strings( 'divx4','lavc', 'copy' );
			$widgets->{'cmbCodec'}->set_usize( 75, 0);
		Add2BoxStart( $widgets->{'hbCodecPass'}, $widgets->{'lblCodec'} );
		Add2BoxStart( $widgets->{'hbCodecPass'}, $widgets->{'cmbCodec'} );
			$widgets->{'lblPass'} = new Gtk::Label( "Pass" );
			$widgets->{'cmbPass'} = new Gtk::Combo();
			$widgets->{'cmbPass'}->set_popdown_strings( '1-pass', '2-pass', '3-pass' );
			$widgets->{'cmbPass'}->set_usize( 75, 0);
			$widgets->{'cmbPass'}->list->select_item( 2 );
		Add2BoxEnd( $widgets->{'hbCodecPass'}, $widgets->{'cmbPass'} );
		Add2BoxEnd( $widgets->{'hbCodecPass'}, $widgets->{'lblPass'} );

		## encoding options
		###################
		$widgets->{'hbEncodingOpts'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbV'}, $widgets->{'hbEncodingOpts'} );
			$widgets->{'lblEncodingOpts'} = new Gtk::Label( "Encoding options" );
			$widgets->{'entryEncodingOpts'} = new Gtk::Entry();
			$widgets->{'entryEncodingOpts'}->set_text( "q=5:min_quant=2:max_quant=8" );
		Add2BoxStart( $widgets->{'hbEncodingOpts'}, $widgets->{'lblEncodingOpts'} );
		Add2BoxFillStart( $widgets->{'hbEncodingOpts'}, $widgets->{'entryEncodingOpts'} );



## START - STOP ----------------------------------------------------------------

		## start
		########
		$widgets->{'btnStart'} = new Gtk::Button( "start" );
	Add2BoxStart( $widgets->{'vbMainTop'}, $widgets->{'btnStart'} );

		## stop
		#######
		$widgets->{'btnStop'} = new Gtk::Button( "stop" );
		$widgets->{'btnStop'}->set_sensitive( $false );
	Add2BoxStart( $widgets->{'vbMainTop'}, $widgets->{'btnStop'} );

		## separator
		############
		$widgets->{'sep4'} = new Gtk::HSeparator();
	Add2BoxStart( $widgets->{'vbMainTop'}, $widgets->{'sep4'} );


## DEBUG -----------------------------------------------------------------------

		## actions label
		################
		$widgets->{'hbActions'} = new Gtk::HBox( $false, 1 );
	Add2BoxStart( $widgets->{'vbMainTop'}, $widgets->{'hbActions'} );
			$widgets->{'lblActions'} = new Gtk::Label( "" );
			$widgets->{'lblActions'}->set_justify( "left" );
			Add2BoxStart( $widgets->{'hbActions'}, $widgets->{'lblActions'} );

## BAR -------------------------------------------------------------------------

		## progress bar
		###############
		$widgets->{'pbarBar'} = new Gtk::ProgressBar;
	Add2BoxStart( $widgets->{'vbMainTop'}, $widgets->{'pbarBar'} );
		$widgets->{'pbarBar'}->set_orientation('left_to_right');
		$widgets->{'pbarBar'}->set_bar_style('continuous');
		$widgets->{'pbarBar'}->set_show_text(1);
		$widgets->{'pbarBar'}->set_activity_mode(0);
		$widgets->{'pbarBar'}->set_text_alignment(0.5, 0.5);
		$widgets->{'pbarBar'}->set_format_string('%P %%');
		$widgets->{'pbarBar'}->configure(0, 0, 100);





	## signals
	##########
	$widgets->{'wdwMain'}->signal_connect( "delete_event", \&wdwMainClose );
	$widgets->{'btnInput'}->signal_connect( "clicked", \&btnInputClicked, $widgets );
	$widgets->{'chkbtnSubFile'}->signal_connect( "toggled", \&chkbtnSubFileToggled, $widgets );
	$widgets->{'btnSubFile'}->signal_connect( "clicked", \&btnSubFileClicked, $widgets );
	$widgets->{'chkbtnAudioID'}->signal_connect( "toggled", \&chkbtnAudioIDToggled, $widgets );
	$widgets->{'chkbtnSubID'}->signal_connect( "toggled", \&chkbtnSubIDToggled, $widgets );


	$widgets->{'entrySize'}->signal_connect( "activate", \&entrySizeActivated, $widgets );
	$widgets->{'entryLength'}->signal_connect( "activate", \&entryLengthActivated, $widgets );
	$widgets->{'entryVideoBrate'}->signal_connect( "changed", \&entryVideoBrateChanged, $widgets );
	$widgets->{'cmbAudioBrate'}->entry->signal_connect( "changed", \&cmbAudioBrateEntryChanged, $widgets );
	$widgets->{'entryScaleWidth'}->signal_connect( "activate", \&entryScaleWidthActivated, $widgets );
	$widgets->{'entryScaleHeight'}->signal_connect( "activate", \&entryScaleHeightActivated, $widgets );
	$widgets->{'rbtnScale43'}->signal_connect( "toggled", \&rbtnScale43Toggled, $widgets );
	$widgets->{'chkbtnOutputFPS'}->signal_connect( "toggled", \&chkbtnOutputFPSToggled, $widgets );
	$widgets->{'entryOutputFPS'}->signal_connect( "activate", \&entryOutputFPSActivated, $widgets );
	$widgets->{'entryEncodingOpts'}->signal_connect( "changed", \&entryEncodingOptsChanged, $widgets );
	$widgets->{'cmbCodec'}->entry->signal_connect( "changed", \&cmbCodecEntryChanged, $widgets );
	$widgets->{'cmbAudioCodec'}->entry->signal_connect( "changed", \&cmbAudioCodecChanged, $widgets );

	$widgets->{'btnStart'}->signal_connect( "clicked", \&btnStartClicked, $widgets );
	$widgets->{'btnStop'}->signal_connect( "clicked", \&btnStopClicked, $widgets );

	bless ($widgets,$class);
	return $widgets;
}

sub MakeMenu
{
	my ($widgets,@menu_items) = @_;

	my $accel_group = new Gtk::AccelGroup();
	my $item_factory = new Gtk::ItemFactory( "Gtk::MenuBar", "<main>", $accel_group );
	$item_factory->create_items( @menu_items );
	$widgets->{'wdwMain'}->add_accel_group( $accel_group );
	return $item_factory->get_widget( "<main>" );
}


## makes my life as a programmer easier
sub Add2Box
{
	my ($parent,$child,$pos) = @_;
	$parent->add( $child );
	$parent->set_child_packing( $child, $false, $false, 2, $pos );
}
sub Add2BoxStart
{
	my ($parent,$child) = @_;
	Add2Box( $parent, $child, "start" );
}
sub Add2BoxEnd
{
	my ($parent,$child) = @_;
	Add2Box( $parent, $child, "end" );
}
sub Add2BoxFill
{
	my ($parent,$child,$pos) = @_;
	$parent->add( $child );
	$parent->set_child_packing( $child, $true, $true, 2, $pos );
}
sub Add2BoxFillStart
{
	my ($parent,$child) = @_;
	Add2BoxFill( $parent, $child, "start" );
}
sub Add2BoxFillEnd
{
	my ($parent,$child) = @_;
	Add2BoxFill( $parent, $child, "end" );
}




1;

